# __init__.py
# -*- coding: utf8 -*-
# vim:fileencoding=utf8 ai ts=4 sts=4 et sw=4
# Copyright 2008 National Research Foundation (South African Radio Astronomy Observatory)
# BSD license - see LICENSE for details

"""Root of katcp package."""
from __future__ import absolute_import, division, print_function

from .client import AsyncClient, BlockingClient, CallbackClient, DeviceClient
from .core import (AsyncReply, AttrDict, DeviceMetaclass, FailReply,
                   KatcpClientError, KatcpDeviceError, KatcpSyntaxError,
                   KatcpTypeError, Message, MessageParser, ProtocolFlags, Sensor)
from .resource_client import KATCPClientResource, KATCPClientResourceContainer
from .sensortree import (AggregateSensorTree, BooleanSensorTree,
                         GenericSensorTree)
from .server import (AsyncDeviceServer, DeviceLogger, DeviceServer,
                     DeviceServerBase)


# Automatically added by katversion
__version__ = '0.9.2'
